# Exercise 7.2: Add a data attribute to a class
# 
# Add a data attribute transactions to the Account 
# class from Sect. 7.2.1. The new attribute counts 
# the number of transactions done in the deposit 
# and withdraw methods. Print the total number of 
# transactions in the dump method. Write a test
# function test_Account() for testing that the 
# implementation of the extended class Account is 
# correct.
# 
# Filename: Account2.

class Account:
    def __init__(self, name, account_number, initial_amount):
        self.name = name
        self.no = account_number
        self.balance = initial_amount
        self.transactions = 0        # NEW
        
    def deposit(self, amount):
        self.balance += amount
        self.transactions += 1       # NEW
        
    def withdraw(self, amount):
        self.balance -= amount
        self.transactions += 1       # NEW
        
    def dump(self):
        s = '%s, %s, balance: %s, transactions: %s' % \
            (self.name, self.no, self.balance, \
            self.transactions)       # NEW
        print(s)

def test_Account():
    amounts = [500, 1500, 6550, -245, -23]
    acc = Account('Nina Olsen', '37542212345', 0)
    for val in amounts:
        if val > 0:
            acc.deposit(val)
        else:
            acc.withdraw(-val)
    # Test balance
    expected = sum(amounts)
    computed = acc.balance
    assert expected == computed, 'Error in balance'
    # Test transactions
    expected = len(amounts)
    computed = acc.transactions
    assert expected == computed, 'Error in transactions'
    
     
