# Exercise 7.3: Add functionality to a class
# 
# In class AccountP from Sect. 7.2.1, introduce 
# a list self._transactions, where each element 
# holds a dictionary with the amount of a 
# transaction and the point of time the 
# transaction took place. Remove the _balance 
# attribute and use instead the _transactions 
# list to compute the balance in the method 
# get_balance. Print out a nicely formatted 
# table of all transactions, their amounts, 
# and their time in a method print_transactions.
# Hint: Use the time or datetime module to get 
# the date and local time.
# 
# Filename: Account3.   

from time import asctime as t

class AccountP:
    def __init__(self, name, account_number, initial_amount):
        self._name = name
        self._no = account_number
        trans = {'amount': initial_amount, 'time': t()}
        self._transactions = [trans]
        
    def deposit(self, amount):
        trans = {'amount': amount, 'time': t()}
        self._transactions.append(trans)
        
    def withdraw(self, amount):
        trans = {'amount': -amount, 'time': t()}
        self._transactions.append(trans) 
        
    def get_balance(self):
        balance = 0
        for e in self._transactions:
            balance += e['amount']
        return balance
        
    def print_transactions(self):
        print('Transactions:\n')
        s = ''
        for tr in self._transactions:
            if tr['amount'] > 0:
                s = s + '%-15s' % 'Deposit'
            else:
                s = s + '%-15s' % 'Withdrawal'
            s = s + '%15g    %s\n' % (tr['amount'], tr['time'])
        s = s + '---------------\n'
        s = s + 'Balance:\t\t%g' % self.get_balance()
        print(s)
        
    def dump(self):
        s = '%s, %s, balance: %s' % \
            (self._name, self._no, self.get_balance())
        print(s)

acc = AccountP('Peter', 2342342, 500)
acc.deposit(400)
acc.deposit(1500)
acc.deposit(2300)
acc.withdraw(600)
acc.withdraw(250)
acc.deposit(1000)
acc.print_transactions()
