# Exercise 7.1: Make a function class
# Make a class F that implements the function
# f(x;a,w) = e^(-ax)sin(wx). A value(x) method 
# computes values of f, while a and w are data 
# attributes. 
#
# Test the class in an interactive session:
# > from F import F
# > f = F(a=1.0, w=0.1)
# > from math import pi
# > print f.value(x=pi)
# 0.013353835137
# > f.a = 2
# > print f.value(pi)
# 0.00057707154012
#
# Filename: F.

from math import exp, sin

class F:
    def __init__(self, a, w):
        self.a = a
        self.w = w
        
    def value(self, x):
        val = exp(-self.a * x)*sin(self.w * x)
        return val
    
    def __call__(self, x):
        val = exp(-self.a * x)*sin(self.w * x)
        return val

f = F(a=1.0, w=2.0)
print(f.value(10))  # Calculate f(x) in x=10 (calls 'value')
print(f(10))        # The same (calls '__call__)

        