# Exercise 6.7: Make a nested dictionary from a file.
#
# The file src/dictstring/human_evolution.txt holds 
# information about various human species and their 
# height, weight, and brain volume. Make a program
# that reads this file and stores the tabular data in 
# a nested dictionary humans.
# The keys in humans correspond to the species name 
# (e.g., homo erectus), and the values are dictionaries 
# with keys for height, weight, brain volume, and when 
# (the latter for when the species lived). For example, 
# humans[’homo neanderthalensis’][’mass’] should equal 
# ’55-70’. Let the program write out the humans 
# dictionary in a nice tabular form similar to that 
# in the file.
#
# Filename: humans.

# A) Read file 'human_evolution.txt' and store
#    contents in a nested dictionary called 'humans'
#

def read_file():
    infile = open('human_evolution.txt', 'r')
    line = infile.readline(); infile.readline(); infile.readline()
    pos = [k for k in range(len(line)) if line[k].isupper()]
    result = {}
    line = infile.readline()
    while line[0] == 'H':
        spec = line[pos[0]:pos[1]].strip()
        when = line[pos[1]:pos[2]].strip()
        heig = line[pos[2]:pos[3]].strip()
        mass = line[pos[3]:pos[4]].strip()
        bvol = line[pos[4]:].strip()
        result[spec] = dict(when=when, height=heig, mass=mass, brainvol=bvol)
        line = infile.readline()
    infile.close()
    return result

humans = read_file()

# B) Let the program write out the humans 
# dictionary in a nice tabular form similar to that 
# in the file.

def write_table():
    format = '%-22s\t%-17s\t%-14s\t%-11s\t%s'
    print(format % ('Species','When','Height','Mass','Volume'))
    for spec in sorted(humans):
        d = humans[spec]
        print(format % (spec, d['when'], d['height'], d['mass'], d['brainvol']))
    
write.table()